angular.module('starter.controllers.articles', [])

.controller('ArticleListingCtrl', function($scope, Article) {
  $scope.loadResults = function() {
    $scope.errorMessage = null;
    $scope.articles = null;

    return Article.query().$promise
    .then(function(articles) {
      angular.forEach(articles, function(article) {
        if(article.published_at) {
          var date = moment(article.published_at, 'YYYY-MM-DD HH:mm:ss');
          article.countdown = date.isValid()? date.fromNow() : null;
        } else {
          article.countdown = null;
        }
        return article;
      });

      $scope.articles = articles;
    })
    .catch(function(message) {
      $scope.errorMessage = 'Error loading articles';
    })
    .finally(function() {
      // Refresher active needs to be false for initial load
      $scope.refresherActive = true;
      $scope.$broadcast('loading.hide');
      $scope.$broadcast('scroll.refreshComplete');
    });
  }

  $scope.loadResults();
})