angular.module('starter.directives', [])
.directive('loadingDirective', function($compile) {
  var loadingTemplate = '<div class="loading-directive"><ion-spinner></ion-spinner></div>';

  var _linker = function(scope, element, attrs) {
    element.html(loadingTemplate);
    $compile(element.contents())(scope);

    scope.$on('loading.hide', function() {
      element.addClass('closing');
    });
    scope.$on('loading.show', function() {
      element.removeClass('closing');
    });
  };

  return {
    restrict: 'E',
    link: _linker,
    scope: {
      content: '='
    }
  };
})

.directive('inappbrowserLinks', function() {
  return {
    restrict: 'A',
    link: function(scope, element) {
      element.on('click', function(e) {
        var link = $(e.target).closest('a[href]');
        if(link.length) {
          window.open(link.attr('href'), '_system');
          // Stop from opening in the app
          e.preventDefault();
        }
      })
    }
  };
})

.directive('transparentTitleBar', function() {
  return {
    restrict: 'A',
    link: function(scope, element) {
      scope.$on('$ionicView.beforeEnter', function() {
        angular.element(document.body).addClass('transparent-title-bar');
      });

      scope.$on('$ionicView.beforeLeave', function() {
        angular.element(document.body).removeClass('transparent-title-bar');
      });
    }
  };
});