angular.module('starter.filters', [])

.filter('dateSuffix', function($filter) {
  var suffixes = ["th", "st", "nd", "rd"];
  return function(input) {
    var day = $filter('date')(input, 'd');
    var relevantDigits = (day < 30) ? day % 20 : day % 30;
    var suffix = (relevantDigits <= 3) ? suffixes[relevantDigits] : suffixes[0];
    return suffix;
  };
})

.filter('escapeHTML', function() {
  return function(text) {
    if(text) {
      return text.
        replace(/&/g, '&amp;').
        replace(/</g, '&lt;').
        replace(/>/g, '&gt;').
        replace(/'/g, '&#39;').
        replace(/"/g, '&quot;');
    }
    return '';
  };
})

.filter('numberFixedLen', function () {
  return function(n, len) {
    var num = parseInt(n, 10);
    len = parseInt(len, 10);
    if(isNaN(num) || isNaN(len)) {
      return n;
    }
    num = ''+num;
    while(num.length < len) {
      num = '0'+num;
    }
    return num;
  };
});